package ar.com.trabajos.broker.client;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;

import ar.com.trabajos.broker.shared.entities.DatosFormAutoDTO;
import ar.com.trabajos.broker.shared.entities.DatosFormPersonaDTO;
import ar.com.trabajos.broker.shared.entities.RequestDTO;
import ar.com.trabajos.broker.shared.entities.ResponseDTO;
import ar.com.trabajos.broker.shared.enums.BrokerEnum;
import ar.com.trabajos.broker.shared.enums.DatosAutoEnum;
import ar.com.trabajos.broker.shared.enums.DatosPersonaEnum;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface BrokerServiceAsync {
	void requestPresupuesto(RequestDTO input, AsyncCallback<ResponseDTO> callback)
			throws IllegalArgumentException;

	void obtenerDatosAuto(AsyncCallback<DatosFormAutoDTO> callback);
	void obtenerDatosPersona(AsyncCallback<DatosFormPersonaDTO> callback);

	void obtenerModelosMarca(int codMarca, int codGrupo,
			AsyncCallback<LinkedHashMap<Integer, String>> callback);

	void guardarDatosRequest(RequestDTO request, AsyncCallback<Void> callback);


	void enviarMail(HashMap<BrokerEnum, ResponseDTO> respuestas,
			HashMap<DatosAutoEnum, String> datosAuto,
			HashMap<DatosPersonaEnum, String> datosPersona,
			AsyncCallback<Void> asyncCallback);

	void obtenerGruposMarca(int codMarca,
			AsyncCallback<LinkedHashMap<Integer, String>> asyncCallback);

	void obtenerAnosFabricacion(int codInfoAuto,
			AsyncCallback<LinkedHashMap<Double, String>> asyncCallback);

	void obtenerCodPostalProvincia(int parseInt,
			AsyncCallback<List<Integer>> asyncCallback);
	
}
