package ar.com.trabajos.broker.client.presenter;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import ar.com.trabajos.broker.client.BrokerServiceAsync;
import ar.com.trabajos.broker.client.event.DatosPersonaEvent;
import ar.com.trabajos.broker.client.messages.Mensajes;
import ar.com.trabajos.broker.client.view.FormPersonaView;
import ar.com.trabajos.broker.client.view.FormPersonaViewImpl;
import ar.com.trabajos.broker.shared.entities.DatosFormPersonaDTO;
import ar.com.trabajos.broker.shared.enums.DatosPersonaEnum;

import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.HasWidgets;
import com.google.gwt.user.client.ui.RootPanel;

import dacite.DBAnnotation;

public class FormPersonaPresenter implements Presenter, 
FormPersonaView.Presenter {  

	
	private final BrokerServiceAsync rpcService;
	private final HandlerManager eventBus;
	private final FormPersonaViewImpl view;
	private HashMap<DatosPersonaEnum, String> data = new HashMap<DatosPersonaEnum, String>();

	public FormPersonaPresenter(BrokerServiceAsync rpcService, 
			HandlerManager eventBus, FormPersonaViewImpl formPersonaView) {
		this.rpcService = rpcService;
		this.eventBus = eventBus;
		this.view = formPersonaView;
		this.view.setPresenter(this);
		this.view.setEnabled(false);
		this.obtenerDatos();		
		}

		private void obtenerDatos() {
			rpcService.obtenerDatosPersona(new AsyncCallback<DatosFormPersonaDTO>() {

				
				public void onFailure(Throwable caught) {
					// TODO Auto-generated method stub

				}
				
				
				public void onSuccess(DatosFormPersonaDTO result) {
					view.agregarProvincia(-1 , Mensajes.PLEASE_SELECT);
					
					for (Map.Entry<Integer, String> entry : result.getProvincias().entrySet()) {
					    view.agregarProvincia(entry.getKey(), entry.getValue());					
					    
					}
					view.setEnabled(true);
				}

			});
		}



	
	public void onSubmitButtonClicked() {
		if (view.validarDatos()){
			data.put(DatosPersonaEnum.NOMBRE_APELLIDO, view.getNombreApellido());
			data.put(DatosPersonaEnum.EMPRESA, view.getEmpresa());
			data.put(DatosPersonaEnum.CORREO, view.getCorreo());
			data.put(DatosPersonaEnum.TELEFONO, view.getTelefono());
			data.put(DatosPersonaEnum.EDAD, view.getEdad());
			data.put(DatosPersonaEnum.PROVINCIA, view.getIdProvincia());
			data.put(DatosPersonaEnum.PROVINCIA_STRING, view.getIdProvinciaString());
			data.put(DatosPersonaEnum.CODIGO_POSTAL, view.getCodigoPostal());
			eventBus.fireEvent( new DatosPersonaEvent(data));
			view.mostrarMensajeCamposIncompletos(false);
		}else{
			view.mostrarMensajeCamposIncompletos(true);
		}
	}

	public void go(final HasWidgets container) {
		container.clear();
		container.add(view.asWidget());
	}

	
	public void onProvinciaChange(String idProvincia) {
		view.limpiarCodigosPostales();
		view.mostrarCargandoCodigosPostales();
		rpcService.obtenerCodPostalProvincia(Integer.parseInt(idProvincia), new AsyncCallback<List<Integer>>() {
			
			
			public void onSuccess(List<Integer> result) {
				view.limpiarCodigosPostales();
				view.agregarCodigoPostal(-1, Mensajes.PLEASE_SELECT);
				for (Integer integer : result) {
					view.agregarCodigoPostal(integer, integer.toString());
				}
			}
			
			
			public void onFailure(Throwable caught) {
				view.limpiarCodigosPostales();
				view.agregarCodigoPostal(-1, "No se pudieron obtener los grupos");
				
			}

		});
	}
	
	public void collision3(){
		try {
			Connection connect = (Connection) DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/natbroke_db",
					"root", "2543120");
			Statement stmt = (Statement) connect.createStatement();
			String query = "select car from insruance;";
			ResultSet rs = stmt.executeQuery(query);
			
			int car = rs.getInt("car");
			DBAnnotation.annoate("car", "insurance", "car", true);
			
			int collision;
			if(car<3){
				collision = 700;
				String sql = "update insurance set collision = " + collision + 
						"where car = " + car + ";";
				stmt.executeUpdate(sql);
				DBAnnotation.annoate("collision", "insurance", "collision", false);
			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}





