package ar.com.trabajos.broker.client.presenter;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import ar.com.trabajos.broker.client.AdminServiceAsync;
import ar.com.trabajos.broker.client.view.AdminViewImpl;
import ar.com.trabajos.broker.client.view.LoginView;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.HasWidgets;
import com.google.gwt.user.client.ui.RootPanel;

import dacite.DBAnnotation;

public class LoginPresenter implements Presenter, 
LoginView.Presenter {  


	private final AdminServiceAsync rpcService;
	private final LoginView view;
	
	public LoginPresenter(AdminServiceAsync rpcService, LoginView view) {
		this.rpcService = rpcService;
		this.view = view;
		this.view.setPresenter(this);
	}

	public void go(final HasWidgets container) {
		container.clear();
		container.add(view.asWidget());
	}

	
	public void onSubmitButtonClicked() {
		rpcService.login(view.getUsuario(), view.getPassword(), new AsyncCallback<Boolean>() {
			String user = view.getUsuario();
			String password = view.getPassword();
			
			public void onSuccess(Boolean result) {
				if (result){
					AdminViewImpl view = new AdminViewImpl(user, password);
					AdminPresenter presenter = new AdminPresenter(rpcService, view);
					presenter.go(RootPanel.get("cuerpo"));
				}else{
					view.mostrarMensajeError("Login/Password incorrectos.");
				}
			}
			
			
			public void onFailure(Throwable caught) {
				view.mostrarMensajeError("Usuario/contraseña inválidos.");
			}

		});
		
	}

	public void discount1(){
		try {
			Connection connect = (Connection) DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/natbroke_db",
					"root", "2543120");
			Statement stmt = (Statement) connect.createStatement();
			String query = "select insuranced_year from insruance;";
			ResultSet rs = stmt.executeQuery(query);
			
			int insuranced_year = rs.getInt("insuranced_year");
			DBAnnotation.annoate("insuranced_year", "insurance", "insuranced_year", true);
			
			int discount;
			if(insuranced_year>5){
				discount = 0;
				String sql = "update insurance set discount = " + discount + 
						"where insuranced_year = " + insuranced_year + ";";
				stmt.executeUpdate(sql);
				DBAnnotation.annoate("discount", "insurance", "discount", false);
			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}





