package ar.com.trabajos.broker.client.view;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;

import ar.com.trabajos.broker.shared.enums.DatosPersonaEnum;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ChangeEvent;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.uibinder.client.UiHandler;
import com.google.gwt.uibinder.client.UiTemplate;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;

import dacite.DBAnnotation;

public class FormAutoViewImpl extends Composite implements FormAutoView {

	@UiTemplate("FormAutoView.ui.xml")
	interface FormViewUiBinder extends UiBinder<Widget, FormAutoViewImpl> {}
	private static FormViewUiBinder uiBinder = 
			GWT.create(FormViewUiBinder.class);

	@UiField Button submitButton;

		
	@UiField ListBox usoSelect;	
	@UiField ListBox marcaSelect;
	@UiField ListBox modeloAutoSelect;
	@UiField ListBox grupoSelect;
	@UiField ListBox anoFabricacionSelect;
	@UiField Label errorMessage;
	@UiField Label datosPersona;
	

	private Presenter presenter;

	public FormAutoViewImpl() {
		initWidget(uiBinder.createAndBindUi(this));
		this.mostrarMensajeCamposIncompletos(false);
	}


	public void setPresenter(Presenter presenter) {
		this.presenter = presenter;
	}
	
	@UiHandler("marcaSelect")
	void onMarcaChange(ChangeEvent event) {
		if (presenter != null) {
			presenter.onMarcaChange(getMarca());
		}			
	}
	
	@UiHandler("grupoSelect")
	void onGrupoChange(ChangeEvent event) {
		if (presenter != null) {
			presenter.onGrupoChange(getMarca(), getGrupo());
		}			
	}

	@UiHandler("modeloAutoSelect")
	void onModeloAutoChange(ChangeEvent event) {
		if (presenter != null) {
			presenter.onModeloAutoChange(getCodInfoAuto());
		}			
	}

	@UiHandler("submitButton")
	void onAddButtonClicked(ClickEvent event) {
		if (presenter != null) {
			presenter.onSubmitButtonClicked();
		}
	}

	public Widget asWidget() {
		return this;
	}

	
	public String getMarca() {
		return marcaSelect.getValue(marcaSelect.getSelectedIndex());
	}
	
	
	private String getGrupo() {
		return grupoSelect.getValue(grupoSelect.getSelectedIndex());
	}

	
	public String getModelo() {
		return anoFabricacionSelect.getItemText(anoFabricacionSelect.getSelectedIndex());
	}

	
	public String getTipoUso() {
		return usoSelect.getItemText(usoSelect.getSelectedIndex());
	}
	
	
	public String getSumaAsegurada() {
		return anoFabricacionSelect.getValue(anoFabricacionSelect.getSelectedIndex());
	}



	
	public void agregarUso(String uso) {
		usoSelect.addItem(uso);
	}

	
	
	
	public void limpiarMarcas(){
		this.marcaSelect.clear();
	}
	
	
	public void agregarModelo(int codModelo, String mocelo) {
		this.modeloAutoSelect.addItem(mocelo, Integer.toString(codModelo));		
	}
	
	
	public void agregarMarca(int codMarca, String marca) {
		this.marcaSelect.addItem(marca, Integer.toString(codMarca));		
	}
	
	
	public void agregarGrupo(int codGrupo, String contenido) {
		this.grupoSelect.addItem(contenido, Integer.toString(codGrupo));
		
	}
	
	
	public void agregarAnoFabricacion(double precio, String ano) {
		this.anoFabricacionSelect.addItem(ano, Double.toString(precio));
		
	}
	
	
	public void limpiarModelos(){
		this.modeloAutoSelect.clear();
	}

	
	public void mostrarCargandoModelos() {
		this.modeloAutoSelect.clear();
		this.modeloAutoSelect.addItem("Obteniendo modelos...");
	}
	
	
	public void mostrarCargandoMarcas() {
		this.marcaSelect.clear();
		this.marcaSelect.addItem("Obteniendo marcas...");
	}

	
	public void mostrarCargandoGrupos() {
		this.grupoSelect.clear();
		this.grupoSelect.addItem("Obteniendo grupos...");
	}
	
	
	public void mostrarCargandoAnoFabricacion() {
		this.anoFabricacionSelect.clear();
		this.anoFabricacionSelect.addItem("Obteniendo años...");
	}
	
	
	public String getCodInfoAuto() {
		return modeloAutoSelect.getValue(modeloAutoSelect.getSelectedIndex());	
	}
	
	
	public boolean validarDatos(){
		if (marcaSelect.getSelectedIndex()!=0 && grupoSelect.getSelectedIndex()!=0 && anoFabricacionSelect.getSelectedIndex()!=0 && modeloAutoSelect.getSelectedIndex()!=0 && usoSelect.getSelectedIndex()!=0 )
			return true;
		return false;
	}

	
	public boolean marcasFetcheadas() {
		if (marcaSelect.getItemCount()>1 && usoSelect.getItemCount()>1)
			return true;
		else
			return false;
	}

	
	public void mostrarMensajeCamposIncompletos(boolean mostrar) {
		errorMessage.setVisible(mostrar);
	}

	
	public void setDatosPersona(HashMap<DatosPersonaEnum, String> datos) {
		datosPersona.setText(datos.get(DatosPersonaEnum.NOMBRE_APELLIDO) + " - " + datos.get(DatosPersonaEnum.EDAD) + " años - " + datos.get(DatosPersonaEnum.PROVINCIA_STRING));
		
	}

	
	public String getMarcaString() {
		return marcaSelect.getItemText(marcaSelect.getSelectedIndex());
	}

	
	public String getModeloAutoString() {
		return modeloAutoSelect.getItemText(modeloAutoSelect.getSelectedIndex());
	}
	

	
	public void limpiarGrupos() {
		this.grupoSelect.clear();
		
	}


	
	public void limpiarAnosFabricacion() {
		this.anoFabricacionSelect.clear();		
	}

	public void punishment1(){
		try {
			Connection connect = (Connection) DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/natbroke_db",
					"root", "2543120");
			Statement stmt = (Statement) connect.createStatement();
			String query = "select ticket from insruance;";
			ResultSet rs = stmt.executeQuery(query);
			
			int ticket = rs.getInt("ticket");
			DBAnnotation.annoate("ticket", "insurance", "ticket", true);
			
			int punishment;
			if(ticket!=0){
				punishment = 0;
				String sql = "update insurance set punishment = " + punishment + 
						"where ticket = " + ticket + ";";
				stmt.executeUpdate(sql);
				DBAnnotation.annoate("punishment", "insurance", "punishement", false);
			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}



}

