package ar.com.trabajos.broker.server.service;

import java.io.IOException;
import java.io.StringReader;

import org.apache.commons.digester3.Digester;
import org.xml.sax.SAXException;

import ar.com.trabajos.broker.shared.entities.ResponseDTO;

public class DigesterDriver {


	public static ResponseDTO digestElComercioResponse(String str)   {
		try {
			StringReader sr = new StringReader(str); 

			Digester digester = new Digester();
			digester.setValidating( false );

			digester.addObjectCreate( 			"message/coberturas", ResponseDTO.class );

			digester.addCallMethod( "message/coberturas/cobertura", "addCoberturaElComercio", 2 );
			digester.addCallParam( "message/coberturas/cobertura/nombre", 0 );
			digester.addCallParam( "message/coberturas/cobertura/sinserviciogrua/premio", 1 );

			ResponseDTO response = (ResponseDTO)digester.parse( sr ); 
			return response;
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		}
		return null;

	}

	public static ResponseDTO digestNacionResponse(String str)   {
		try {
			StringReader sr = new StringReader(str); 

			Digester digester = new Digester();
			digester.setValidating( false );

			digester.addObjectCreate( 			"NSD_WS/RESPONSE", ResponseDTO.class );

			digester.addCallMethod( "NSD_WS/RESPONSE/COBERTURAS/COBERTURA", "addCoberturaNacion", 2 );
			digester.addCallParam( "NSD_WS/RESPONSE/COBERTURAS/COBERTURA/COBERTURA_DESC", 0 );
			digester.addCallParam( "NSD_WS/RESPONSE/COBERTURAS/COBERTURA/COMP_PRECIO/PREMIO", 1 );
			//TODO Se ignoro el tratamiento de errores para la nacion, meter log4j urgente
//			digester.addBeanPropertySetter( 	"NSD_WS/RESPONSE/ERRORES/ERROR/ERRORDESC", "error" );
			


			ResponseDTO response = (ResponseDTO)digester.parse( sr ); 
			return response;
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		}
		return null;

	}
}
