package ar.com.trabajos.broker.server.service;


import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.ServletContext;

import org.apache.commons.io.IOUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.commons.mail.HtmlEmail;

import ar.com.trabajos.broker.shared.entities.ResponseDTO;
import ar.com.trabajos.broker.shared.enums.BrokerEnum;
import ar.com.trabajos.broker.shared.enums.DatosAutoEnum;
import ar.com.trabajos.broker.shared.enums.DatosPersonaEnum;

public class SendMail{
	private Log log = LogFactory.getLog(SendMail.class);

	private static String USERNAME 	= "cotizadorweb@nat-brokers.com";
	private static String PASSWORD 	= "Cotizadorweb2012";
	private static String SERVER 	= "mail.nat-brokers.com";
	private static int 	  PORT 		=  25;
	private static String FROM 		= "cotizadorweb@nat-brokers.com";
	private static String SUBJECTPRE= "Cotización de su vehículo: ";
	private  String subject;
	private static String BCC		= "COTIZADORWEB@NAT-BROKERS.COM";
	private String to;
	private String nombreApellido;
	private String marca;
	private String modeloAuto;
	private String modelo;
	private String provincia;
	private String codigoPostal;
	private String telefono;
	private String mailContent= null;
	private HashMap<BrokerEnum, ResponseDTO> cotizaciones=null;
	//private ServletContext servletContext;

	public SendMail(HashMap<BrokerEnum, ResponseDTO> respuestas,
			HashMap<DatosPersonaEnum, String> datosPersona,
			HashMap<DatosAutoEnum, String> datosAuto,
			ServletContext servletContext) {
		this.to=datosPersona.get(DatosPersonaEnum.CORREO);
		this.cotizaciones=respuestas;
		this.nombreApellido=datosPersona.get(DatosPersonaEnum.NOMBRE_APELLIDO);
		this.provincia=datosPersona.get(DatosPersonaEnum.PROVINCIA_STRING);
		this.codigoPostal=datosPersona.get(DatosPersonaEnum.CODIGO_POSTAL);
		this.telefono=datosPersona.get(DatosPersonaEnum.TELEFONO);
		this.marca=datosAuto.get(DatosAutoEnum.MARCA_STRING);
		this.modeloAuto=datosAuto.get(DatosAutoEnum.MODELO_AUTO_STRING);
		this.modelo=datosAuto.get(DatosAutoEnum.MODELO);
		this.subject= SUBJECTPRE + marca + " - " + modeloAuto + " - " + modelo;
		//this.servletContext=servletContext;
		servletContext.getContextPath();
		try {
		   InputStream inputStream = servletContext.getResourceAsStream("/mail/mail.html");
		   StringWriter writer = new StringWriter();
		   IOUtils.copy(inputStream, writer, "utf-8");
		   mailContent = writer.toString();
		} catch (IOException e) {
			log.error("Error en lectura del archivo mail.html: " + org.apache.commons.lang.exception.ExceptionUtils.getStackTrace(e));			
		}
	}
	
	public SendMail(String nombreApellido, String empresa, String correo, String comentario){
		this.to=BCC;
		this.subject="Contacto";
		mailContent= "<HTML><BODY><H2>Nombre y apellido</H2>" + nombreApellido + "<BR/><H2>Empresa</H2>"  + empresa+ "<BR/><H2>Correo</H2>" + correo + "<BR/><H2>Comentario</H2>"+comentario;
	}

	public void enviar() {
		try {
			HtmlEmail email = new HtmlEmail();
			email.setHostName(SERVER);
			email.setSmtpPort(PORT);
			email.addTo(to);
			email.setFrom(FROM, "National Brokers");
			email.setSubject(subject);
			email.setCharset("UTF-8");
			email.setAuthentication(USERNAME,PASSWORD); 
			//TODO Comentar en test
			email.addBcc(BCC);
			
			//TODO cuando esto se quiera hacer bien, se hara asi
			//String cid = email.embed(servletContext.getResource("/mail/img/logo_header2.png"), "Apache logo");

			//Carga de datos del mail
			String prefijo=null;
			HashMap<String, String> replacements = new HashMap<String, String>();
			replacements.put("persona", nombreApellido + " - " + provincia + " - " + codigoPostal + " - " + telefono);
			replacements.put("auto", marca + " - " + modeloAuto + " - " + modelo);
			for (BrokerEnum broker : cotizaciones.keySet()) {
				ResponseDTO response = cotizaciones.get(broker);
				switch (response.getBroker()) {
				case ELCOMERCIO:
					prefijo="ec";
					break;
				case LIBERTY:
					prefijo="l";
					break;
				case NACION:
					prefijo="n";
					break;
				case ALLIANZ:
					prefijo="a";
					break;
				}

				replacements.put(prefijo + "Rc", "$ " + Integer.toString(response.getRc()));
				replacements.put(prefijo + "Tc", "$ " +Integer.toString(response.getTc()));
				replacements.put(prefijo + "Tcf", "$ " +Integer.toString(response.getTcf()));
				replacements.put(prefijo + "Tcfg", "$ " +Integer.toString(response.getTcfg()));
				replacements.put(prefijo + "Tr", "$ " +Integer.toString(response.getTr()));
				replacements.put(prefijo + "Tt", "$ " +Integer.toString(response.getTt()));
			}
			Pattern pattern = Pattern.compile("\\[(.+?)\\]");
			Matcher matcher = pattern.matcher(mailContent);

			StringBuffer buffer = new StringBuffer();
			while (matcher.find()) {
				String replacement = replacements.get(matcher.group(1));
				if (replacement != null) {
					if (replacement.equals("$ 0"))
						replacement="X";
					//			                      matcher.appendReplacement(buffer, replacement);
					// see comment 
					matcher.appendReplacement(buffer, "");
					buffer.append(replacement);
				}else{
					matcher.appendReplacement(buffer, "");
					buffer.append("X");
				}
			}
			matcher.appendTail(buffer);
			mailContent=buffer.toString();
			//FIN CARGA DATOS EMAIL
			
			//Prueba para ver si pone acentos en asunto
			email.addPart(mailContent, "text/html;charset=UTF-8");
//			email.setHtmlMsg(mailContent);
			email.send();
		} catch (org.apache.commons.mail.EmailException e) {
			log.error("Error en envio de email " + e.getMessage());			
		}catch (Exception e) {
			log.error("Error en envio de email: " + org.apache.commons.lang.exception.ExceptionUtils.getStackTrace(e));			
		}
	}
	
	public void enviarContacto() {
		try {
			HtmlEmail email = new HtmlEmail();
			email.setHostName(SERVER);
			email.setSmtpPort(PORT);
			email.addTo(to);
			//TODO Remover esto
			//email.addBcc("federicoaw@gmail.com");
			email.setFrom(FROM, "National Brokers");
			email.setSubject(subject);
			email.setCharset("UTF-8");
			email.setAuthentication(USERNAME,PASSWORD); 
			
			email.addPart(mailContent, "text/html;charset=UTF-8");
//			email.setHtmlMsg(mailContent);
			email.send();
		} catch (org.apache.commons.mail.EmailException e) {
			log.error("Error en envio de email " + e.getMessage());			
		}catch (Exception e) {
			log.error("Error en envio de email: " + org.apache.commons.lang.exception.ExceptionUtils.getStackTrace(e));
			e.printStackTrace();
		}
	}
}

