package ar.com.trabajos.broker.server.service;



import java.io.*;
import java.util.HashMap;

import org.w3c.dom.*;

import ar.com.trabajos.broker.shared.entities.RequestDTO;

import javax.xml.parsers.*;

import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class XMLBuilder {

	public static String buildXMLLiberty(RequestDTO input, HashMap<String, String> datosParaXML, boolean granizo){
		try{

			DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
			Document doc = docBuilder.newDocument();

			Element cotizacion = doc.createElement("DatosCotizacion");
			cotizacion.setAttribute("Ticket", "1080007004");
			doc.appendChild(cotizacion);

			Element datosCliente = doc.createElement("DatosCliente");
			cotizacion.appendChild(datosCliente);

			//Sexo, M
			Element sexo = doc.createElement("Sexo");
			sexo.setTextContent("M");
			datosCliente.appendChild(sexo);

			Element provincia = doc.createElement("Provincia");
			provincia.setTextContent(datosParaXML.get("codProvincia"));
			datosCliente.appendChild(provincia);

			Element localidad = doc.createElement("Localidad");
			localidad.setTextContent(datosParaXML.get("codLocalidad"));
			datosCliente.appendChild(localidad);

			Element situacionIVA = doc.createElement("SituacionIVA");
			situacionIVA.setTextContent("05");
			datosCliente.appendChild(situacionIVA);

			//Como es consumidor final, la cibb debe ser excento
			Element condicionIIBB = doc.createElement("CondicionIIBB");
			condicionIIBB.setTextContent("4");
			datosCliente.appendChild(condicionIIBB);

			Element fechaNacimiento = doc.createElement("FechaNacimiento");
			fechaNacimiento.setTextContent(datosParaXML.get("fechaNacimiento"));
			datosCliente.appendChild(fechaNacimiento);

			Element clausulaAjuste = doc.createElement("ClausulaAjuste");
			//Cobertura RC no lleva clausula de ajuste
//			if (!datosParaXML.get("codProducto").equals("0743")){					
				clausulaAjuste.setTextContent("1");
//			}
			datosCliente.appendChild(clausulaAjuste);
			//Fin Datos Cliente

			Element datosVehiculo = doc.createElement("DatosVehiculo");
			cotizacion.appendChild(datosVehiculo);

			//Datos Vehiculo
			Element marca = doc.createElement("Marca");
			marca.setTextContent(datosParaXML.get("codMarca"));
			datosVehiculo.appendChild(marca);

			Element modelo = doc.createElement("Modelo");
			modelo.setTextContent(datosParaXML.get("codModelo"));
			datosVehiculo.appendChild(modelo);

			Element anio = doc.createElement("Anio");
			anio.setTextContent(input.getModelo());
			datosVehiculo.appendChild(anio);

			//TODO El xls dice que siempre debe ser 0
			Element sumaAsegurada = doc.createElement("SumaAsegurada");
			sumaAsegurada.setTextContent(input.getSumaAsegurada());
			datosVehiculo.appendChild(sumaAsegurada);

			Element destino = doc.createElement("Destino");
			destino.setTextContent(datosParaXML.get("destino"));
			datosVehiculo.appendChild(destino);

			//TODO El xls dice que siempre debe ser N
			Element esRCM = doc.createElement("EsRCM");
			esRCM.setTextContent("N");
			datosVehiculo.appendChild(esRCM);

			Element aniosSiniestralidad = doc.createElement("AniosSiniestralidad");
			aniosSiniestralidad.setTextContent("0");
			datosVehiculo.appendChild(aniosSiniestralidad);			
			//Fin Datos Vehiculo

			Element datosPropuesta = doc.createElement("DatosPropuesta");
			cotizacion.appendChild(datosPropuesta);

			//Datos Propuesta
			Element producto = doc.createElement("Producto");
			producto.setTextContent(datosParaXML.get("codProducto"));
			datosPropuesta.appendChild(producto);

			Element productor = doc.createElement("Productor");
			productor.setTextContent("2080201");
			datosPropuesta.appendChild(productor);

			Element planComercial = doc.createElement("PlanComercial");
			planComercial.setTextContent("18");
			datosPropuesta.appendChild(planComercial);

			Element grupoAfinidad = doc.createElement("GrupoAfinidad");
			datosPropuesta.appendChild(grupoAfinidad);			

			Element formaPago = doc.createElement("FormaPago");
			formaPago.setTextContent("1017");
			datosPropuesta.appendChild(formaPago);

			Element franquicia = doc.createElement("Franquicia");
			franquicia.setTextContent("1");
			datosPropuesta.appendChild(franquicia);

			//Ignora las cuotas, el precio se basa unicamente en vigencia anual/semestral
			Element cuotas = doc.createElement("Cuotas");
			cuotas.setTextContent("1001");
			datosPropuesta.appendChild(cuotas);

			Element fechaVigenciaDesde = doc.createElement("FechaVigenciaDesde");
			fechaVigenciaDesde.setTextContent(datosParaXML.get("fechaVigencia"));
			datosPropuesta.appendChild(fechaVigenciaDesde);

			//Se asume vigencia semestral, las otras rebotan siempre
			Element vigenciaContrato = doc.createElement("VigenciaContrato");
			vigenciaContrato.setTextContent("2");
			datosPropuesta.appendChild(vigenciaContrato);

			Element accesorios = doc.createElement("Accesorios");
			datosPropuesta.appendChild(accesorios);

			Element adicionales = doc.createElement("Adicionales");				
			//El plan liberty mas debe tener obligatoriamente los tres adicionales
			if (datosParaXML.get("codProducto").equals("0337") || datosParaXML.get("codProducto").equals("0052") 
					|| datosParaXML.get("codProducto").equals("0687")
					|| datosParaXML.get("codProducto").equals("0339")){
				Element item1 = doc.createElement("Item");
				item1.setTextContent("CL");
				adicionales.appendChild(item1);

				Element item2 = doc.createElement("Item");
				item2.setTextContent("PR");
				adicionales.appendChild(item2);

				Element item3 = doc.createElement("Item");
				item3.setTextContent("DP");
				adicionales.appendChild(item3);
			}	
			if (granizo){
				Element item1 = doc.createElement("Item");
				item1.setTextContent("GR");
				adicionales.appendChild(item1);
			}
			
			datosPropuesta.appendChild(adicionales);

			Element descuentos = doc.createElement("Descuentos");
			datosPropuesta.appendChild(descuentos);

			Element servicios = doc.createElement("Servicios");
			servicios.appendChild(adicionales);

			Element validaSoloFormulas = doc.createElement("ValidaSoloFormulas");
			validaSoloFormulas.setTextContent("true");
			datosPropuesta.appendChild(validaSoloFormulas);

			Element descuentoEspecial = doc.createElement("DescuentoEspecial");
			descuentoEspecial.setTextContent("false");
			datosPropuesta.appendChild(descuentoEspecial);

			//Fin Datos Propuesta

			/////////////////
			//Output the XML

			//set up a transformer
			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer();
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			trans.setOutputProperty(OutputKeys.INDENT, "yes");

			//create string from xml tree
			StringWriter sw = new StringWriter();
			StreamResult result = new StreamResult(sw);
			DOMSource source = new DOMSource(doc);
			trans.transform(source, result);
			String xmlString = sw.toString();

			//print xml
			//			System.out.println("Here's the xml:\n\n" + xmlString);
			return xmlString;
		} catch (Exception e) {
			System.out.println(e);
			return null;
		}
	}

	public static String buildXMLNacion(RequestDTO input, HashMap<String, String> datosParaXML){
		try{

			DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
			Document doc = docBuilder.newDocument();

			Element nsdWs = doc.createElement("NSD_WS");
			doc.appendChild(nsdWs);

			Element request = doc.createElement("REQUEST");
			nsdWs.appendChild(request);

			Element requestId = doc.createElement("REQUEST_ID");
			requestId.setTextContent("123456");
			request.appendChild(requestId);

			//Se asigna el codigo de usuario de prueba
			Element brokerCod = doc.createElement("BROKER_COD");
			brokerCod.setTextContent("052012");
			request.appendChild(brokerCod);

			Element producCod = doc.createElement("PRODUC_COD");
			producCod.setTextContent("199997");
			request.appendChild(producCod);

			Element planComCod = doc.createElement("PLANCOM_COD");
			planComCod.setTextContent("NAC1");
			request.appendChild(planComCod);
			
			Element moneda = doc.createElement("MONEDA");
			moneda.setTextContent("1");
			request.appendChild(moneda);
			
			Element tomador = doc.createElement("TOMADOR");
			tomador.setTextContent(input.getNombreApellido());
			request.appendChild(tomador);

			Element infoAutoCod = doc.createElement("INFOAUTO_COD");
			infoAutoCod.setTextContent(datosParaXML.get("infoAutoCod"));
			request.appendChild(infoAutoCod);

			Element anoFab = doc.createElement("AÑO_FAB");
			anoFab.setTextContent(input.getModelo());
			request.appendChild(anoFab);

			Element sumaAsegurada = doc.createElement("SUMA_ASEG");
			sumaAsegurada.setTextContent(input.getSumaAsegurada());
			request.appendChild(sumaAsegurada);

			Element postCod = doc.createElement("POST_COD");
			postCod.setTextContent(input.getCodigoPostal());
			request.appendChild(postCod);

			//Tipo de persona 1
			Element tipoPersona = doc.createElement("TIPO_PERSONA");
			tipoPersona.setTextContent("1");
			request.appendChild(tipoPersona);

			Element catIva = doc.createElement("CAT_IVA");
			catIva.setTextContent("5");
			request.appendChild(catIva);

			Element catIngresosBrutos = doc.createElement("CAT_INGRESOS_BRUTOS");
			catIngresosBrutos.setTextContent("I1");
			request.appendChild(catIngresosBrutos);

			Element resPag = doc.createElement("RES_PAG");
			resPag.setTextContent("1");
			request.appendChild(resPag);

			Element forPagCod = doc.createElement("FORPAG_COD");
			forPagCod.setTextContent("0");
			request.appendChild(forPagCod);

			//Condicion de pago cuatro cuotas > 04. Esto no cambia el precio, lo importante es el mod fac
			Element conPagCod = doc.createElement("CONPAG_COD");
			conPagCod.setTextContent("1");
			request.appendChild(conPagCod);

			Element modFacCod = doc.createElement("MODFAC_COD");
			modFacCod.setTextContent("06");
			request.appendChild(modFacCod);

			Element vigDesde = doc.createElement("VIG_DESDE");
			vigDesde.setTextContent(datosParaXML.get("vigDesde"));
			request.appendChild(vigDesde);

			Element usoVeh = doc.createElement("USO_VEH");
			usoVeh.setTextContent(datosParaXML.get("usoVeh"));
			request.appendChild(usoVeh);

			Element esCeroKm = doc.createElement("ES_CERO_KM");
			esCeroKm.setTextContent(datosParaXML.get("esCeroKm"));
			request.appendChild(esCeroKm);

			Element tieneGnc = doc.createElement("TIENE_GNC");
			tieneGnc.setTextContent("N");
			request.appendChild(tieneGnc);

			Element sumaAsegGnc = doc.createElement("SUMA_ASEG_GNC");
			sumaAsegGnc.setTextContent("0");
			request.appendChild(sumaAsegGnc);

			Element tieneAlarmaSat = doc.createElement("TIENE_ALARMA_SAT");
			tieneAlarmaSat.setTextContent("N");
			request.appendChild(tieneAlarmaSat);



			/////////////////
			//Output the XML

			//set up a transformer
			TransformerFactory transfac = TransformerFactory.newInstance();
			Transformer trans = transfac.newTransformer();
			trans.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
			trans.setOutputProperty(OutputKeys.INDENT, "yes");

			//create string from xml tree
			StringWriter sw = new StringWriter();
			StreamResult result = new StreamResult(sw);
			DOMSource source = new DOMSource(doc);
			trans.transform(source, result);
			String xmlString = sw.toString();

			//print xml
//			System.out.println("Here's the xml:\n\n" + xmlString);
			return xmlString;
		} catch (Exception e) {
			System.out.println(e);
			return null;
		}
	}
}
